from __future__ import absolute_import, division, print_function
import numpy as np
from subprocess import call
import argparse
import pickle, os, timeit, time
import matplotlib.pyplot as plt
from datetime import datetime

import sys
parent_path = os.path.dirname(os.path.realpath(__file__))
grandparent_path = os.path.dirname(parent_path)
sys.path.append(grandparent_path)
sys.path.append(parent_path)

from Utils.common import load_run_data

os.environ['CUDA_VISIBLE_DEVICES'] = '0'

n_train_tasks = 10

root_saved_dir = 'saved/'

parser = argparse.ArgumentParser()

parser.add_argument('--n_pixels_shuffles', type=int, help='In case of "Shuffled_Pixels": how many pixels swaps',
                    default=100)

parser.add_argument('--complexity_type', type=str,
                    help=" The learning objective complexity type",
                    default='PAC_Bayes_Abel_lambda')
# 'NoComplexity' /  'Variational_Bayes' / 'PAC_Bayes_Pentina'   NewBoundMcAllaster / NewBoundSeeger'" / 'PAC_Bayes_lambda' / 'PAC_Bayes_Abel'

parser.add_argument('--data_prior_ratio', type= float,
                    help="  proportion of data in data dependent prior",
                    default= 0.001)


# args = parser.parse_args()
# n_pixels_shuffles = args.n_pixels_shuffles
# call(['python', 'Meta_DataDependentPrior/DP_main_Meta_Bayes.py',
#       '--run-name', 'Shuffled_{}_Pixels_{}_Tasks_{}_Comp_Data_dependent_{}_data_prior_ratio'.format(n_pixels_shuffles, n_train_tasks, args.complexity_type, args.data_prior_ratio),
#       '--data-source', 'MNIST',
#       '--data-transform', 'Shuffled_Pixels',
#       '--n_pixels_shuffles', str(n_pixels_shuffles),
#       '--n_train_tasks', str(n_train_tasks),
#       '--limit_train_samples_in_test_tasks', '2000',
#       '--model-name',   'FcNet3',
#       '--complexity_type',  args.complexity_type, # 'NewBoundMcAllaster' 'NewBoundSeeger' # 'PAC_Bayes_lambda' 'PAC_Bayes_quad' 'PAC_Bayes_variational_role'
#       '--n_test_tasks', '10', 
#       '--data_prior_ratio', str(args.data_prior_ratio),
#       '--n_meta_train_epochs', '150',  # 150
#       '--n_meta_test_epochs', '200',  # 200
#       '--meta_batch_size', '5',      
#       '--data_prior_train_epochs', '20',  # default 20: training 20 epochs # Abel's note: original version :2
#       '--data_prior_test_epochs', '20', # default 20: testing 20 epochs
#       '--data_prior_batch_size', '128',
#       '--mode', 'MetaTrain',  # 'MetaTrain'  \ 'LoadMetaModel'
#       ])

num_different_data_prior_ratio = 10

for i_data_prior_ratio in range(num_different_data_prior_ratio):
      args = parser.parse_args()
      n_pixels_shuffles = args.n_pixels_shuffles
      args.data_prior_ratio = 0.1 * i_data_prior_ratio
      call(['python', 'Meta_DataDependentPrior/DP_main_Meta_Bayes.py',
            '--run-name', 'Shuffled_{}_Pixels_{}_Tasks_{}_Comp_Data_dependent_{}_data_prior_ratio'.format(n_pixels_shuffles, n_train_tasks, args.complexity_type, args.data_prior_ratio),
            '--data-source', 'MNIST',
            '--data-transform', 'Shuffled_Pixels',
            '--n_pixels_shuffles', str(n_pixels_shuffles),
            '--n_train_tasks', str(n_train_tasks),
            '--limit_train_samples_in_test_tasks', '2000',
            '--model-name',   'FcNet3',
            '--complexity_type',  args.complexity_type, # 'NewBoundMcAllaster' 'NewBoundSeeger' # 'PAC_Bayes_lambda' 'PAC_Bayes_quad' 'PAC_Bayes_variational_role'
            '--n_test_tasks', '10', 
            '--data_prior_ratio', str(args.data_prior_ratio),
            '--n_meta_train_epochs', '150',  # 150
            '--n_meta_test_epochs', '200',  # 200
            '--meta_batch_size', '5',      
            '--data_prior_train_epochs', '20',  # default 20: training 20 epochs # Abel's note: original version :2
            '--data_prior_test_epochs', '20', # default 20: testing 20 epochs
            '--data_prior_batch_size', '128',
            '--mode', 'MetaTrain',  # 'MetaTrain'  \ 'LoadMetaModel'
            ])