from __future__ import absolute_import, division, print_function
import numpy as np
from subprocess import call
import argparse
import pickle, os, timeit, time
import matplotlib.pyplot as plt
from datetime import datetime

import sys
parent_path = os.path.dirname(os.path.realpath(__file__))
grandparent_path = os.path.dirname(parent_path)
sys.path.append(grandparent_path)
sys.path.append(parent_path)

from Utils.common import load_run_data

os.environ['CUDA_VISIBLE_DEVICES'] = '1'

n_train_tasks = 10

root_saved_dir = 'saved/'

parser = argparse.ArgumentParser()

parser.add_argument('--n_pixels_shuffles', type=int, help='In case of "Shuffled_Pixels": how many pixels swaps',
                    default=100)

parser.add_argument('--complexity_type', type=str,
                    help=" The learning objective complexity type",
                    default='PAC_Bayes_improved_lambda')
# 'NoComplexity' /  'Variational_Bayes' / 'PAC_Bayes_Pentina'   NewBoundMcAllaster / NewBoundSeeger'" / 'PAC_Bayes_lambda' / 'PAC_Bayes_improved'

parser.add_argument('--data_prior_ratio', type= float,
                    help="  proportion of data in data dependent prior",
                    default= 0.7) # 0.7 * 60,000 = 42,000  ## optimal k-ERM localized prior


args = parser.parse_args()
n_pixels_shuffles = args.n_pixels_shuffles
call(['python', 'Meta_DataDependentPrior/Single_task_ERM.py',
      '--run-name', 'Shuffled_{}_Pixels_{}_Tasks_Single_Tasks_ERM'.format(n_pixels_shuffles, n_train_tasks),
      '--data-source', 'MNIST',
      '--data-transform', 'Shuffled_Pixels',
      '--n_pixels_shuffles', str(n_pixels_shuffles),
      '--n_train_tasks', str(n_train_tasks),
      '--limit_train_samples_in_test_tasks', '2000',
      '--model-name',   'FcNet3',
      '--complexity_type',  args.complexity_type, # 'NewBoundMcAllaster' 'NewBoundSeeger' # 'PAC_Bayes_lambda' 'PAC_Bayes_quad' 'PAC_Bayes_variational_role'
      '--n_test_tasks', '10', 
      '--data_prior_ratio', str(args.data_prior_ratio),
      '--n_meta_train_epochs', '150',  # 150
      '--n_meta_test_epochs', '200',  # 200
      '--meta_batch_size', '5',      
      '--data_prior_train_epochs', '20',  # default 20: training 20 epochs # improved's note: original version :2
      '--data_prior_test_epochs', '20', # default 20: testing 20 epochs
      '--data_prior_batch_size', '128',
      '--mode', 'MetaTrain',  # 'MetaTrain'  \ 'LoadMetaModel'
      ])