# Implementation of k-ERM localized prior algorithm on novel task

we build our project based on the implementation of the paper Tianyu Liu, Jie Lu, Zheng Yan, Guangquan Zhang, “PAC-Bayes Bounds for Meta-learning with Data-Dependent Prior”,  Arxiv 2021 
[https://github.com/tyliu22/Meta-learning-PAC-Bayes-bound-with-data-depedent-prior]


## Data

The data sets are downloaded automatically. Specify the main data path in the file 'Data_Path.py'

## Reproducing experiments in our paper:

python Meta_DataDependentPrior/run_MPB_ShuffledPixels_single_task_PAC_Bayes.py   -- Run PAC-Bayes single-task lambda bound-minimization algorthim with k-ERM locazlied prior. 


python Meta_DataDependentPrior/run_MPB_ShuffledPixels_single_task_ERM.py   -- Run purely ERM algorithm over 2,000 training samples on the novel task. 

   
 ## Project Structure
```
.
|----Data_Path.py  
|----Meta_DataDependentPrior/ 
|    |----DP_Analyze_Prior.py  
|    |----DP_AvargeTransfer.py  
|    |----DP_Get_Objective_MPB.py  
|    |----DP_main_Meta_Bayes.py  
|    |----DP_meta_test_Bayes.py  
|    |----DP_meta_train_Bayes_finite_tasks.py  
|    |----DP_meta_train_Bayes_infinite_tasks.py  
|    |----DP_run_MPB_PermutedLabels_TasksN.py  
|    |----DP_run_MPB_ShuffledPixels_TasksN.py  
|    |----DP_show_TasksN_Plots.py  
|    |----DP_test_data_prior_learning.py  
|    |----DP_train_data_prior_learning.py  
|----ML_data_sets/
|----Models/
|    |----deterministic_models.py  
|    |----layer_inits.py  
|    |----stochastic_inits.py  
|    |----stochastic_layers.py  
|    |----stochastic_models.py  
|----PriorMetaLearning/
|    |----Analyze_Prior.py  
|    |----AvargeTransfer.py  
|    |----Get_Objective_MPB.py  
|    |----main_Meta_Bayes.py  
|    |----meta_test_Bayes.py  
|    |----meta_train_Bayes_finite_tasks.py  
|    |----meta_train_Bayes_infinite_tasks.py  
|    |----run_MPB_PermutedLabels_TasksN.py  
|    |----run_MPB_PermuteLabels.py  
|    |----run_MPB_ShuffledPixels.py  
|    |----run_MPB_ShuffledPixels_TasksN.py  
|    |----saved/
|    |----show_TasksN_Plots.py  
|----README.md  
|----requirements.txt  
|----tree.py  
|----Utils/
|    |----Bayes_utils.py  
|    |----common.py  
|    |----data_gen.py  
|    |----DP_data_gen.py  
|    |----imagenet_data.py  
|    |----omniglot.py  
|    |----Resize_ImageNet.py  
```